#include <Windows.h>
#include "LinkedList.h"

struct LinkedList* LinkedListCreate()
{
	return (struct LinkedList*)GlobalAlloc(GPTR, sizeof(struct LinkedList));
}

void LinkedListDestroy(struct LinkedList* pList, LinkedListDestroyCallback callback)
{
	if (pList)
	{
		struct LinkedListNode* pNode = pList->First;

		while (pNode)
		{
			struct LinkedListNode* pNext = pNode->Next;
			if (callback)
				callback(pNode);
			GlobalFree(pNode->Key);
			GlobalFree(pNode);
			pNode = pNext;
		}

		GlobalFree(pList);
	}
}

struct LinkedListNode* LinkedListGet(struct LinkedList* pList, const PTCHAR szKey, const BOOL bCreate)
{
	if (pList)
	{
		struct LinkedListNode* pNode = pList->First;
		PTCHAR pszKey = szKey ? szKey : TEXT("");

		while (pNode)
		{
			if (lstrcmpi(pNode->Key, pszKey) == 0)
				return pNode;
			pNode = pNode->Next;
		}

		if (bCreate)
		{
			pNode = (struct LinkedListNode*)GlobalAlloc(GPTR, sizeof(struct LinkedListNode));
			pNode->Key = (PTCHAR)GlobalAlloc(GPTR, sizeof(TCHAR) * (lstrlen(pszKey) + 1));
			lstrcpy(pNode->Key, pszKey);
			pNode->Next = pList->First;
			pList->First = pNode;
			return pNode;
		}
	}

	return NULL;
}